package com.winhc.fast.query.handler;

import org.apache.hadoop.hbase.Cell;
import org.apache.hadoop.hbase.client.Result;
import org.apache.hadoop.hbase.util.Bytes;

import java.util.HashMap;
import java.util.Map;
import java.util.function.Function;

/**
 * @author: XuJiakai
 * 2022/5/25 11:41
 */
public class HbaseResultHandler implements Function<Result, Map<String, String>> {
    @Override
    public Map<String, String> apply(Result result) {
        return transform(result);
    }

    public static Map<String, String> transform(Result result) {
        if (result == null || result.isEmpty()) {
            return null;
        }
        Map<String, String> columnMap = new HashMap<>();
        String rowKey = null;
        for (Cell cell : result.listCells()) {
            if (rowKey == null) {
                rowKey = Bytes.toString(cell.getRowArray(), cell.getRowOffset(), cell.getRowLength());
            }
            columnMap.put(Bytes.toString(cell.getQualifierArray(), cell.getQualifierOffset(), cell.getQualifierLength()), Bytes.toString(cell.getValueArray(), cell.getValueOffset(), cell.getValueLength()));
        }
        columnMap.put("rowkey", rowKey);
        return columnMap;
    }
}
