package com.winhc.fast.query.vo;

import com.winhc.fast.query.utils.BigDecimalUtil;
import lombok.Getter;

/**
 * @Author: XuJiakai
 * @Date: 2020/9/2 16:55
 * @Description:
 */
@Getter
public class ResponseVo<T> {
    private Boolean success;
    private String msg;
    private T data;
    private String duration;

    public static <T> ResponseVo success(long startTime, T data) {
        long endTime = System.currentTimeMillis();
        ResponseVo<T> responseVo = new ResponseVo<T>();
        responseVo.success = true;
        responseVo.msg = "success";
        responseVo.data = data;
        responseVo.duration = BigDecimalUtil.div(endTime - startTime, 1000L, 3) + "s";
        return responseVo;
    }

    public static <T> ResponseVo failure(long startTime, String errorMsg) {
        long endTime = System.currentTimeMillis();
        ResponseVo<T> responseVo = new ResponseVo<T>();
        responseVo.success = false;
        responseVo.msg = errorMsg;
        responseVo.duration = BigDecimalUtil.div(endTime - startTime, 1000L, 3) + "s";
        return responseVo;
    }

    public static <T> ResponseVo failure( String errorMsg) {
        ResponseVo<T> responseVo = new ResponseVo<T>();
        responseVo.success = false;
        responseVo.msg = errorMsg;
        return responseVo;
    }
}
